function XpraProtocolWorkerHost(){this.worker=null,this.packet_handler=null,this.packet_ctx=null}function XpraProtocol(){this.verify_connected_timer=0,this.is_worker=!1,this.packet_handler=null,this.packet_ctx=null,this.websocket=null,this.raw_packets=[],this.cipher_in=null,this.cipher_in_block_size=null,this.cipher_out=null,this.rQ=[],this.sQ=[],this.mQ=[],this.header=[],this.process_interval=0,this.packet_encoder="bencode"}var protocol;CONNECT_TIMEOUT=15e3,XpraProtocolWorkerHost.prototype.open=function(uri){var me=this;this.worker?this.worker.postMessage({c:"o",u:uri}):(this.worker=new Worker("js/Protocol.js"),this.worker.addEventListener("message",function(e){var data=e.data;switch(data.c){case"r":me.worker.postMessage({c:"o",u:uri});break;case"p":me.packet_handler&&me.packet_handler(data.p,me.packet_ctx);break;case"l":this.log(data.t);break;default:this.error("got unknown command from worker"),this.error(e.data)}},!1))},XpraProtocolWorkerHost.prototype.close=function(){this.worker.postMessage({c:"c"})},XpraProtocolWorkerHost.prototype.terminate=function(){this.worker.postMessage({c:"t"})},XpraProtocolWorkerHost.prototype.send=function(packet){this.worker.postMessage({c:"s",p:packet})},XpraProtocolWorkerHost.prototype.set_packet_handler=function(callback,ctx){this.packet_handler=callback,this.packet_ctx=ctx},XpraProtocolWorkerHost.prototype.set_cipher_in=function(caps,key){this.worker.postMessage({c:"z",p:caps,k:key})},XpraProtocolWorkerHost.prototype.set_cipher_out=function(caps,key){this.worker.postMessage({c:"x",p:caps,k:key})},XpraProtocolWorkerHost.prototype.enable_packet_encoder=function(packet_encoder){this.worker.postMessage({c:"p",pe:packet_encoder})},XpraProtocol.prototype.close_event_str=function(event){var code_mappings={1e3:"Normal Closure",1001:"Going Away",1002:"Protocol Error",1003:"Unsupported Data",1004:"(For future)",1005:"No Status Received",1006:"Abnormal Closure",1007:"Invalid frame payload data",1008:"Policy Violation",1009:"Message too big",1010:"Missing Extension",1011:"Internal Error",1012:"Service Restart",1013:"Try Again Later",1014:"Bad Gateway",1015:"TLS Handshake"},msg="";if(event.code)try{void 0!==code_mappings[event.code]?msg+="'"+code_mappings[event.code]+"' ("+event.code+")":msg+=""+event.code,event.reason&&(msg+=": '"+event.reason+"'")}catch(e){this.error("cannot parse websocket event:",e),msg="unknown reason"}else msg="unknown reason (no websocket error code)";return msg},XpraProtocol.prototype.open=function(uri){var me=this,ctx=this.packet_ctx;function handle(packet){me.packet_handler(packet,ctx)}this.raw_packets=[],this.rQ=[],this.sQ=[],this.mQ=[],this.header=[],this.websocket=null,this.verify_connected_timer=setTimeout(function(){handle(["error","connection timed out",0])},CONNECT_TIMEOUT);try{this.websocket=new WebSocket(uri,"binary")}catch(e){return void handle(["error",""+e,0])}this.websocket.binaryType="arraybuffer",this.websocket.onopen=function(){me.verify_connected_timer&&(clearTimeout(me.verify_connected_timer),me.verify_connected_timer=0),handle(["open"])},this.websocket.onclose=function(event){handle(["close",me.close_event_str(event)])},this.websocket.onerror=function(event){handle(["error",me.close_event_str(event),event.code||0])},this.websocket.onmessage=function(e){me.rQ.push(new Uint8Array(e.data)),setTimeout(function(){me.process_receive_queue()},this.process_interval)}},XpraProtocol.prototype.close=function(){this.websocket&&(this.websocket.onopen=null,this.websocket.onclose=null,this.websocket.onerror=null,this.websocket.onmessage=null,this.websocket.close(),this.websocket=null)},XpraProtocol.prototype.protocol_error=function(msg){this.error("protocol error:",msg),this.websocket.onopen=null,this.websocket.onclose=null,this.websocket.onerror=null,this.websocket.onmessage=null,this.header=[],this.rQ=[],this.packet_handler(["close",msg])},XpraProtocol.prototype.process_receive_queue=function(){for(;this.websocket&&this.do_process_receive_queue(););},XpraProtocol.prototype.error=function(){console&&console.error.apply(console,arguments)},XpraProtocol.prototype.log=function(){console&&console.log.apply(console,arguments)},XpraProtocol.prototype.do_process_receive_queue=function(){var i=0,j=0;if(this.header.length<8&&0<this.rQ.length){for(;this.header.length<8&&0<this.rQ.length;){var slice=this.rQ[0],needed=8-this.header.length,n=Math.min(needed,slice.length);for(i=0;i<n;i++)this.header.push(slice[i]);slice.length>needed?this.rQ[0]=slice.subarray(n):this.rQ.shift()}if(this.header[0]!==ord("P")){var msg="invalid packet header format: "+this.header[0];if(1<this.header.length){for(var hex="",p=0;p<this.header.length;p++){var v=this.header[p].toString(16);v.length<2?hex+="0"+v:hex+=v}msg+=": 0x"+hex}return this.protocol_error(msg),!1}}if(this.header.length<8)return!1;var msg=this.header[1],proto_crypto=2&msg;if(proto_crypto&&(msg&=-3),8&msg&&(msg&=-9),!(1<msg&&16!=msg)){var level=this.header[2];if(32&level)return this.protocol_error("lzo compression is not supported"),!1;if(20<=(index=this.header[3]))return this.protocol_error("invalid packet index: "+index),!1;var packet_size=0;for(i=0;i<4;i++)packet_size=(packet_size*=256)+this.header[4+i];var packet_data,padding=0,rsize=(proto_crypto&&0<this.cipher_in_block_size&&(packet_size+=padding=this.cipher_in_block_size-packet_size%this.cipher_in_block_size),0);for(i=0,j=this.rQ.length;i<j;++i)rsize+=this.rQ[i].length;if(rsize<packet_size)return!1;if(this.header=[],this.rQ[0].length==packet_size)packet_data=this.rQ.shift();else for(packet_data=new Uint8Array(packet_size),rsize=0;rsize<packet_size;){needed=packet_size-rsize;(slice=this.rQ[0]).length>needed?(packet_data.set(slice.subarray(0,needed),rsize),rsize+=needed,this.rQ[0]=slice.subarray(needed)):(packet_data.set(slice,rsize),rsize+=slice.length,this.rQ.shift())}if(proto_crypto){this.cipher_in.update(forge.util.createBuffer(uintToString(packet_data)));var decrypted=this.cipher_in.output.getBytes();if(!decrypted||decrypted.length<packet_size-padding)return this.error("error decrypting packet using",this.cipher_in),decrypted.length<packet_size-padding?this.error(" expected "+(packet_size-padding)+" bytes, but got "+decrypted.length):this.error(" decrypted:",decrypted),this.raw_packets=[],0<this.rQ.length;for(packet_data=new Uint8Array(packet_size-padding),i=0;i<packet_size-padding;i++)packet_data[i]=decrypted[i].charCodeAt(0)}if(0!=level&&(packet_data=16&level?lz4.decode(packet_data):64&level?new Uint8Array(BrotliDecode(packet_data)):new Zlib.Inflate(packet_data).decompress()),0<index){if(this.raw_packets[index]=packet_data,4<=this.raw_packets.length)return this.protocol_error("too many raw packets: "+this.raw_packets.length),!1}else{var me,packet=null;try{for(var index in packet=(1==msg?rdecodelegacy:16==msg?rdecodeplus:bdecode)(packet_data),this.raw_packets)packet[index]=this.raw_packets[index];this.raw_packets={}}catch(e){return this.error("error decoding packet",e),this.error("packet="+packet_data),this.raw_packets=[],0<this.rQ.length}try{if("draw"===packet[0]){var img_data=packet[7];if("string"==typeof img_data){for(var u8a=new Uint8Array(img_data.length),i=0,j=img_data.length;i<j;++i)u8a[i]=img_data.charCodeAt(i);packet[7]=u8a}}else if("sound-data"===packet[0]){var sound_data=packet[2];if("string"==typeof sound_data){for(u8a=new Uint8Array(sound_data.length),i=0,j=sound_data.length;i<j;++i)u8a[i]=sound_data.charCodeAt(i);packet[2]=u8a}}this.is_worker?(this.mQ[this.mQ.length]=packet,me=this,setTimeout(function(){me.process_message_queue()},this.process_interval)):this.packet_handler(packet,this.packet_ctx)}catch(e){this.error("error processing packet "+packet[0]+": "+e)}}return 0<this.rQ.length}this.protocol_error("we can't handle this protocol flag yet: "+msg)},XpraProtocol.prototype.enable_packet_encoder=function(packet_encoder){this.packet_encoder=packet_encoder},XpraProtocol.prototype.process_send_queue=function(){for(;0!==this.sQ.length&&this.websocket;){var packet=this.sQ.shift();if(!packet)return;var proto_flags=0,bdata=null;try{if("bencode"==this.packet_encoder)bdata=bencode(packet),proto_flags=0;else if("rencode"==this.packet_encoder)bdata=rencodelegacy(packet),proto_flags=1;else{if("rencodeplus"!=this.packet_encoder)throw"invalid packet encoder: "+this.packet_encoder;bdata=rencodeplus(packet),proto_flags=16}}catch(e){this.error("Error: failed to encode packet:",packet),this.error(" with packet encoder",this.packet_encoder),this.error(e);continue}var payload_size=bdata.length;if(this.cipher_out){proto_flags|=2;var padding_size=this.cipher_out_block_size-payload_size%this.cipher_out_block_size,input_data=null;if("string"==typeof bdata)input_data=bdata;else{for(var c=[],i=0;i<bdata.length;i+=32768)c.push(String.fromCharCode.apply(null,bdata.subarray(i,i+32768)));input_data=c.join("")}if(padding_size)for(var padding_char=String.fromCharCode(padding_size),i=0;i<padding_size;i++)input_data+=padding_char;this.cipher_out.update(forge.util.createBuffer(input_data),"utf8"),bdata=this.cipher_out.output.getBytes()}var actual_size=bdata.length,packet_data=new Uint8Array(actual_size+8);packet_data[0]="P".charCodeAt(0),packet_data[1]=proto_flags,packet_data[2]=0;for(i=packet_data[3]=0;i<4;i++)packet_data[7-i]=payload_size>>8*i&255;if("object"==typeof bdata&&bdata.constructor===Uint8Array)packet_data.set(bdata,8);else for(i=0;i<actual_size;i++)packet_data[8+i]=ord(bdata[i]);this.websocket&&this.websocket.send(new Uint8Array(packet_data).buffer)}},XpraProtocol.prototype.process_message_queue=function(){for(;0!==this.mQ.length;){var packet=this.mQ.shift();if(!packet)return;var raw_buffers=[];"draw"===packet[0]&&"buffer"in packet[7]?raw_buffers.push(packet[7].buffer):"sound-data"===packet[0]&&"buffer"in packet[2]&&raw_buffers.push(packet[2].buffer),postMessage({c:"p",p:packet},raw_buffers)}},XpraProtocol.prototype.send=function(packet){this.sQ[this.sQ.length]=packet;var me=this;setTimeout(function(){me.process_send_queue()},this.process_interval)},XpraProtocol.prototype.set_packet_handler=function(callback,ctx){this.packet_handler=callback,this.packet_ctx=ctx},XpraProtocol.prototype.set_cipher_in=function(caps,key){var me=this;this.setup_cipher(caps,key,function(cipher,block_size,secret,iv){me.cipher_in_block_size=block_size,me.cipher_in=forge.cipher.createDecipher(cipher,secret),me.cipher_in.start({iv:iv})})},XpraProtocol.prototype.set_cipher_out=function(caps,key){var me=this;this.setup_cipher(caps,key,function(cipher,block_size,secret,iv){me.cipher_out_block_size=block_size,me.cipher_out=forge.cipher.createCipher(cipher,secret),me.cipher_out.start({iv:iv})})},XpraProtocol.prototype.setup_cipher=function(caps,key,setup_fn){if(!key)throw"missing encryption key";var cipher=caps.cipher||"AES";if("AES"!=cipher)throw"unsupported encryption specified: '"+cipher+"'";var key_salt=caps["cipher.key_salt"],iterations=("string"!=typeof key_salt&&(key_salt=String.fromCharCode.apply(null,key_salt)),caps["cipher.key_stretch_iterations"]);if(iterations<100||1e6<iterations)throw"invalid number of iterations: "+iterations;var key_size=caps["cipher.key_size"]||32;if([32,24,16].indexOf(key_size)<0)throw"invalid key size '"+key_size+"'";var key_stretch=caps["cipher.key_stretch"]||"PBKDF2";if("PBKDF2"!=key_stretch.toUpperCase())throw"invalid key stretching function "+key_stretch;key_stretch=(caps["cipher.key_hash"]||"SHA1").toLowerCase(),key=forge.pkcs5.pbkdf2(key,key_salt,iterations,key_size,key_stretch),key_salt=caps["cipher.mode"]||"CBC",iterations=0;if("CBC"==key_salt)iterations=32;else if(["CFB","CTR"].indexOf(key_salt)<0)throw"unsupported AES mode '"+key_salt+"'";key_size=caps["cipher.iv"];if(!key_size)throw"missing IV";setup_fn(cipher+"-"+key_salt,iterations,key,key_size)},"object"==typeof window&&"object"==typeof document&&window.document===document||(importScripts("lib/bencode.js","lib/zlib.js","lib/lz4.js","lib/es6-shim.js","lib/brotli_decode.js","lib/forge.js","lib/rencode.js"),(protocol=new XpraProtocol).is_worker=!0,protocol.set_packet_handler(function(packet,ctx){var raw_draw_buffer=[];"draw"===packet[0]&&packet[7].hasOwnProperty("buffer")&&(raw_draw_buffer=packet[7].buffer,packet[7]=null),postMessage({c:"p",p:packet},raw_draw_buffer)},null),self.addEventListener("message",function(e){var data=e.data;switch(data.c){case"o":protocol.open(data.u);break;case"s":protocol.send(data.p);break;case"p":protocol.enable_packet_encoder(data.pe);break;case"x":protocol.set_cipher_out(data.p,data.k);break;case"z":protocol.set_cipher_in(data.p,data.k);break;case"c":protocol.close();break;case"t":self.close();break;default:postMessage({c:"l",t:"got unknown command from host"})}},!1),postMessage({c:"r"}));